// -*- C++ -*-
/*!
 * @file  facedetect.cpp
 * @brief face detect
 * $Date$
 *
 * $Id$
 */

#include "facedetect.h"
#include "Camera.h"

#include "cv.h"
#include "highgui.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <math.h>
#include <float.h>
#include <limits.h>
#include <time.h>
#include <ctype.h>

#ifdef _EiC
#define WIN32
#endif
static CvMemStorage* storage = 0;
static CvHaarClassifierCascade* cascade = 0;
long xx1;
long yy1;
IplImage* src = NULL;
IplImage* buf2 = NULL;
IplImage* buf3 = NULL;
CvCapture* capture = 0;
const char* cascade_name =
    "haarcascade_frontalface_alt.xml";
void detect_and_draw( IplImage* image);
// Module specification
// <rtc-template block="module_spec">
static const char* facedetect_spec[] =
  {
    "implementation_id", "facedetect",
    "type_name",         "facedetect",
    "description",       "face detect",
    "version",           "0.1",
    "vendor",            "Osaka Univ.",
    "category",          "Generic",
    "activity_type",     "DataFlowComponent",
    "max_instance",      "",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables

    ""
  };
// </rtc-template>

facedetect::facedetect(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    m_ImageDataIn("ImageData", m_ImageData),
    m_ImageData2Out("ImageData2", m_ImageData2),
    m_XOut("X", m_X),
    m_YOut("Y", m_Y),
    
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  registerInPort("ImageData", m_ImageDataIn);
  
  // Set OutPort buffer
  registerOutPort("ImageData2", m_ImageData2Out);
  registerOutPort("X", m_XOut);
  registerOutPort("Y", m_YOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

}

facedetect::~facedetect()
{
}


RTC::ReturnCode_t facedetect::onInitialize()
{
  // <rtc-template block="bind_config">
  // Bind variables and configuration variable
  //cvNamedWindow("window",0);
  // </rtc-template>
  return RTC::RTC_OK;
}



/*
RTC::ReturnCode_t facedetect::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t facedetect::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t facedetect::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t facedetect::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t facedetect::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t facedetect::onExecute(RTC::UniqueId ec_id)
{
int i;
m_ImageDataIn.read();

src = cvCreateImage( cvSize(160,120), 8, 3 );
for(i=0;i<m_ImageData.data.length();i++){
    src->imageData[i]=m_ImageData.data[i];
    //printf("test\n");
  }
//printf("%d\n",src->depth);


/*
src=cvLoadImage("sample1.jpg",CV_LOAD_IMAGE_UNCHANGED);
if(src==NULL){
puts("dame");
}
*/
storage = cvCreateMemStorage(0);
detect_and_draw(src);
m_X.data=xx1;
m_Y.data=yy1;
//printf("%ld,%ld\n",m_X.data,m_Y.data);
//cvShowImage("window",src);
//cvWaitKey(100);
//src=cvQueryFrame(capture);

  m_ImageData2.data.length(src->imageSize);
  //memcpy(m_ImageData2.data,src->imageData2,src->imageSize);

  

for(i=0;i<m_ImageData2.data.length();i++){
    m_ImageData2.data[i]=src->imageData[i];
  }

  //m_ImageData.data[0]=src->imageData[0];
 
  m_ImageData2Out.write();
m_XOut.write();
m_YOut.write();
  return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t facedetect::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t facedetect::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t facedetect::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t facedetect::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t facedetect::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void facedetectInit(RTC::Manager* manager)
  {
    RTC::Properties profile(facedetect_spec);
    manager->registerFactory(profile,
                             RTC::Create<facedetect>,
                             RTC::Delete<facedetect>);
  }
  
};

void detect_and_draw( IplImage* img)
{

   static CvScalar colors[] = 
    {
        {{0,0,255}},
        {{0,128,255}},
        {{0,255,255}},
        {{0,255,0}},
        {{255,128,0}},
        {{255,255,0}},
        {{255,0,0}},
        {{255,0,255}}
    };

    double scale = 1.3;
    IplImage* gray = cvCreateImage( cvSize(160,120), 8, 1 );
    //IplImage* gray = cvCloneImage( img );
   IplImage* small_img = cvCreateImage( cvSize( cvRound (160/scale),
                         cvRound (120/scale)),
                     8, 1 );
    int i;
cascade = (CvHaarClassifierCascade*)cvLoad( cascade_name, 0, 0, 0 );
   if( !cascade )
    {
        fprintf( stderr, "ERROR: Could not load classifier cascade\n" );
        fprintf( stderr,
        "Usage: facedetect --cascade=\"<cascade_path>\" [filename|camera_index]\n" );
    }

   cvCvtColor( img, gray, CV_BGR2GRAY );

   cvResize( gray, small_img, CV_INTER_LINEAR );

    cvEqualizeHist( small_img, small_img );

    cvClearMemStorage( storage );

       double t = (double)cvGetTickCount();
        CvSeq* faces = cvHaarDetectObjects( small_img, cascade, storage,
                                            1.1, 2, 0,
                                            cvSize(30, 30) );
      
 t = (double)cvGetTickCount() - t;
        //printf( "detection time = %gms\n", t/((double)cvGetTickFrequency()*1000.) );
      
 for( i = 0; i < (faces ? faces->total : 0); i++ )
        {
            CvRect* r = (CvRect*)cvGetSeqElem( faces, i );
            CvPoint center;
            int radius;
            center.x = cvRound((r->x + r->width*0.5)*scale);
            center.y = cvRound((r->y + r->height*0.5)*scale);
            radius = cvRound((r->width + r->height)*0.25*scale);
            cvCircle( img, center, radius, colors[i%8], 3, 8, 0 );
xx1=(long)center.x;
yy1=(long)center.y;
        }

}

